package sopaletras;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: Sopa de Letras</p>
 * <p>Description: Crea nuevas sopas de letras a partir de palabras que el usuario da</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Independiente</p>
 * @author Adriana Blanco Nez
 * @version 1.0
 * Creada utilizando el asistente de diseo de JBuilder 9, acta como la clase controladora
 */

public class Interfaz extends JFrame {
  JPanel contentPane;
  JToolBar jToolBar = new JToolBar();
  JButton nuevaSopaJButton = new JButton();
  JButton nuevaPalabraJButton = new JButton();
  JButton eliminarPalabraJButton = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JButton verSolucionJButton = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jList1 = new JList();
  JTextArea jTextArea1 = new JTextArea();
  Generador generador = new Generador();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JScrollPane jScrollPane2 = new JScrollPane();

  //Construct the frame
  public Interfaz() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(sopaletras.Interfaz.class.getResource("openFile.png"));
    image2 = new ImageIcon(sopaletras.Interfaz.class.getResource("closeFile.png"));
    image3 = new ImageIcon(sopaletras.Interfaz.class.getResource("help.png"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setSize(new Dimension(510, 497));
    this.setTitle("Generador Sopa de Letras");
    nuevaSopaJButton.setMnemonic('0');
    nuevaSopaJButton.setText("Nueva sopa");
    nuevaSopaJButton.addActionListener(new Interfaz_nuevaSopaJButton_actionAdapter(this));
    nuevaSopaJButton.setMaximumSize(new Dimension(80, 27));
    nuevaSopaJButton.setMinimumSize(new Dimension(80, 27));
    nuevaSopaJButton.setPreferredSize(new Dimension(80, 27));
    nuevaSopaJButton.setToolTipText("Generar nueva sopa de letras");
    nuevaSopaJButton.setIcon(null);
    nuevaPalabraJButton.setMaximumSize(new Dimension(100, 27));
    nuevaPalabraJButton.setMinimumSize(new Dimension(100, 27));
    nuevaPalabraJButton.setPreferredSize(new Dimension(100, 27));
    nuevaPalabraJButton.setToolTipText("Insertar una nueva palabra");
    nuevaPalabraJButton.setIcon(null);
    nuevaPalabraJButton.setText("Insertar palabra");
    nuevaPalabraJButton.addActionListener(new Interfaz_nuevaPalabraJButton_actionAdapter(this));
    eliminarPalabraJButton.setMnemonic('0');
    eliminarPalabraJButton.setText("Eliminar palabra");
    eliminarPalabraJButton.addActionListener(new Interfaz_eliminarPalabraJButton_actionAdapter(this));
    eliminarPalabraJButton.setMaximumSize(new Dimension(100, 27));
    eliminarPalabraJButton.setMinimumSize(new Dimension(100, 27));
    eliminarPalabraJButton.setPreferredSize(new Dimension(100, 27));
    eliminarPalabraJButton.setToolTipText("Eliminar una palabra de la lista");
    eliminarPalabraJButton.setIcon(null);
    contentPane.setMinimumSize(new Dimension(300, 300));
    contentPane.setPreferredSize(new Dimension(150, 150));
    jToolBar.setBounds(new Rectangle(0, 0, 771, 29));
    verSolucionJButton.setMaximumSize(new Dimension(80, 27));
    verSolucionJButton.setMinimumSize(new Dimension(80, 27));
    verSolucionJButton.setPreferredSize(new Dimension(80, 27));
    verSolucionJButton.setToolTipText("Solucion a ltima sopa letras");
    verSolucionJButton.setText("Solucion");
    verSolucionJButton.addActionListener(new Interfaz_verSolucionJButton_actionAdapter(this));
    jScrollPane1.setBounds(new Rectangle(60, 73, 211, 55));
    jTextArea1.setText("");
    jLabel1.setText("Lista de Palabras:");
    jLabel1.setBounds(new Rectangle(61, 50, 97, 17));
    jLabel2.setText("Ultima Sopa de Letras :");
    jLabel2.setBounds(new Rectangle(63, 143, 119, 18));
    jScrollPane2.setBounds(new Rectangle(62, 180, 278, 252));
    jToolBar.add(nuevaSopaJButton);
    jToolBar.add(nuevaPalabraJButton);
    jToolBar.add(eliminarPalabraJButton);
    contentPane.add(jToolBar, null);
    jToolBar.add(verSolucionJButton, null);
    contentPane.add(jScrollPane1, null);
    contentPane.add(jLabel1, null);
    contentPane.add(jLabel2, null);
    contentPane.add(jScrollPane2, null);
    jScrollPane2.getViewport().add(jTextArea1, null);
    jScrollPane1.getViewport().add(jList1, null);
    llenarLista();
    //jList1.setSelectionMode(JList.);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    Interfaz_AboutBox dlg = new Interfaz_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public void llenarLista(){
    //String s[] = {"1","2","3","4","5","6","7","8"};
    //this.jList1 = new JList(s);

  }

  public void rellenarLista(){
    //String s[] = {"1","2","3","4","5","6","7","8","9","10","11","12"};
    this.jList1 = new JList(this.generador.getLista());
    this.jScrollPane1.getViewport().removeAll();
    this.jScrollPane1.getViewport().add(jList1, null);

  }

  public void dspSopa(String s){
    this.jTextArea1.removeAll();
    this.jTextArea1.setText(s);
  }

  void nuevaSopaJButton_actionPerformed(ActionEvent e) {
    boolean listo = false;
    int i = 0;
    if(this.generador.hayPalabras()){
      while(!listo){
        String p = JOptionPane.showInputDialog(this,
            "De que tamao es la sopa de letras?", "Sopa de Letras",
            JOptionPane.QUESTION_MESSAGE);
        try {
          i = Integer.parseInt(p);
          if(i >= 10){
            listo = true;
          }
          else{
            JOptionPane.showMessageDialog(this,
                "Digite un tamao vlido para la sopa de letras", "Sopa de Letras",
                                                   JOptionPane.INFORMATION_MESSAGE);
          }
        }
        catch (Exception exc) {
          listo = false;
        }
      }
      this.generador.generar(i);
      this.dspSopa(this.generador.getSopa());
    }
    else{
      JOptionPane.showMessageDialog(this,
          "No existen palabras dentro de la lista", "Sopa de Letras",
                                             JOptionPane.INFORMATION_MESSAGE);
    }
  }

  void nuevaPalabraJButton_actionPerformed(ActionEvent e) {
    boolean necesario = true;
    String p = null;
    while(necesario){
      p = JOptionPane.showInputDialog(this,"Digite la palabra que desea insertar: ","Sopa de Letras",JOptionPane.INFORMATION_MESSAGE);
      if(p.compareTo("") != 0){
        necesario = false;
      }
    }
    this.generador.insertar(p);
    this.rellenarLista();
  }

  void eliminarPalabraJButton_actionPerformed(ActionEvent e) {
    String s = (String)jList1.getSelectedValue();
    if(s != null){
      this.generador.eliminar(s);
      this.rellenarLista();
    }
    else{
      JOptionPane.showMessageDialog(this,"No se ha elegido ninguna palabra dentro de la lista", "Sopa de Letras", JOptionPane.ERROR_MESSAGE);
    }
  }

  void verSolucionJButton_actionPerformed(ActionEvent e) {
    this.dspSopa(this.generador.sopa.getSol());
  }
}

class Interfaz_nuevaSopaJButton_actionAdapter implements java.awt.event.ActionListener {
  Interfaz adaptee;

  Interfaz_nuevaSopaJButton_actionAdapter(Interfaz adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.nuevaSopaJButton_actionPerformed(e);
  }
}

class Interfaz_nuevaPalabraJButton_actionAdapter implements java.awt.event.ActionListener {
  Interfaz adaptee;

  Interfaz_nuevaPalabraJButton_actionAdapter(Interfaz adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.nuevaPalabraJButton_actionPerformed(e);
  }
}

class Interfaz_eliminarPalabraJButton_actionAdapter implements java.awt.event.ActionListener {
  Interfaz adaptee;

  Interfaz_eliminarPalabraJButton_actionAdapter(Interfaz adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.eliminarPalabraJButton_actionPerformed(e);
  }
}

class Interfaz_verSolucionJButton_actionAdapter implements java.awt.event.ActionListener {
  Interfaz adaptee;

  Interfaz_verSolucionJButton_actionAdapter(Interfaz adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.verSolucionJButton_actionPerformed(e);
  }
}