/**
 * <p>Title: Pirmide</p>
 * <p>Description: Dibuja una pirmide de asteriscos de una altura determinada</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Independiente</p>
 * @author Edgar Casasola Murillo
 * @author Jos Francisco Villegas Madrigal
 * @version 1.0
 */
/**
 *La clase Piramide sirve para crear y dibujar pirmides de asteriscos de una altura determinada.
 */
public class Piramide {
 /**
  *Almacena el valor de la altura de la pirmide en lneas. 
  */
  private int altura;
/**
 *Este es el constructor por omisin de la clase. Establece el valor por defecto de "altura" con el valor 3.   
 */
 public Piramide(){
  altura = 3;
 }
 /**
 * Establece el valor de la altura al crear el objeto   
 */
 public Piramide(int altura){
   this.altura = altura;
 }
 /**
  * Asigna el valor recibido por parmetro a "altura".
  * @param alturaAsignada El valor de la altura que tendr la pirmide de asteriscos.
  */
 public void setAltura(int alturaAsignada){
  altura = alturaAsignada;
 }
 
/**
 * Devuelve el valor de la "altura".
 * @return El valor de la altura de la pirmide.
 */
 public int getAltura(){
  return altura;
 }
 /**
  * Dibuja la pirmide de asteriscos de acuerdo a la altura ya determinada, este mtodo es apropiado
  * para poner en prctica el uso de ciclos for anidados.
  */
 public void dibujar(){
    // DEBEN PROGRAMAR ESTO PARA QUE QUEDE ASI
    // Altura 6
    //     *
    //    ***
    //   *****
    //  *******
    // *********
    //***********
  // Calcula dependiendo de la altura la cantidad inicial de blancos y asteriscos

  int cantidadDeBlancosEnLaLinea = 0;
  int cantidadDeAsteriscosEnLaLinea = 0;
  if(altura>1)
     cantidadDeBlancosEnLaLinea = altura-1;
  if(altura>0)
     cantidadDeAsteriscosEnLaLinea = 1;

  // Imprime tantas lneas como tenga la pirmide de altura
  // f es el contador de filas

  for(int f=0;f<altura;f++){  // seala la linea
     // En cada linea imprime los blancos correspondientes
     // b es el contador de blancos por lnea
     for(int b=0;b<=cantidadDeBlancosEnLaLinea;b++){
        System.out.print(" ");
     }
     // En cada linea imprime los asteriscos correspondientes
     // a es el contador de asteriscos por lnea
     for(int a=0;a<=cantidadDeAsteriscos;a++){   // da los asteriscos
        System.out.print("*");
     }
     System.out.println();

     // calcula cuantos blancos y cuantos asteriscos tiene la linea siguiente
     cantidadDeBlancosEnLaLinea--; // la siguiente linea tiene un blanco menos
     cantidadDeAsteriscosEnLaLinea+=2; // La siguiente linea tiene dos asteriscos ms que la anterior


  }
 }
}