/**
 * <p>Title: Pensionado</p>
 * <p>Description: Usado para mostrar el uso de estructuras de control</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Independiente</p>
 * @author Edgar Casasola Murillo
 * @author Jos Francisco Villegas Madrigal
 * @version 1.0
 */

/**
 * crea pensionados; usado para mostrar el uso de estructuras de control.
 * Observe cmo los valores de los atributos privados son de "solo lectura" para las otras clases
 * Considera til la aparicin de tales funciones en este programa? Por qu?
 */
public class Pensionado {

  /**
   * bandera de pensionados.
   */
  private boolean pensionar;

  /**
   * edad de la persona a pensionarse.
   */
  private int edad;

  /**
   * genero del postulante.
   */
  private char genero;

  /**
   * bandera para controlar la condicin de las cuotas.
   */
  private boolean cumplioCuotas;

  /**
   * constructor por omisin, establece los valores de los atributos de manera consistente.
   */
  public Pensionado(){
     this.edad = 0;
     this.genero = 'M';
     this.cumplioCuotas = false;
   }

  /**
   * establece los valores de la clase con los valores recibidos por parmetro.
   * @param edad representa el valor de la edad.
   * @param genero char para el gnero.
   * @param cumplioCuotas boolean de las cuotas cumplidas.
   */
  public Pensionado(int edad, char genero, boolean cumplioCuotas){
    this.edad = edad;
    this.genero = genero;
    this.cumplioCuotas = cumplioCuotas;
  }

  /**
   * Retorna el valor del gnero.
   * @return el genero del postulante.
   */
  public char getGenero(){
    return this.genero;
  }

  /**
   * Retorna el valor de la edad de la persona.
   * @return la edad del postulante.
   */
  public int getEdad(){
    return this.edad;
  }

  /**
   * Retorna la condicin de las cuotas.
   * @return el valor de la bandera de la condicin.
   */
  public boolean getCumplioCuotas(){
    return this.cumplioCuotas;
  }

  /**
   *  Retorna el valor de la bandera pensionar.
   *  @return el valor de la bandera pensionar.
   */
  public boolean getPensionar(){
    return this.pensionar;
  }

  /**
   * Devuelve verdadero si la persona se puede pensionar y falso en caso contrario.
   */
  public void pensionar(){

    this.pensionar = false;
    if(this.genero == 'M'){//si es mujer
      if((cumplioCuotas)&&(edad >= 60)){
        this.pensionar = true;
      }
      else{
        if(!(cumplioCuotas)&&(edad >= 65)){
          this.pensionar = true;
        }
      }
    }
    else{ //si es hombre
      if(this.genero == 'H'){
        if((cumplioCuotas)&&(edad >= 65)){
          this.pensionar = true;
        }
        else{
          if(!(cumplioCuotas)&&(edad >= 70)){
            this.pensionar = true;
          }
        }
      }
    }
  }

  /**
   * imprime en pantalla
   */
  public void estado(){
    if(this.pensionar){
      System.out.print("Felicidades, usted se ha pensionado! \n");
    }
    else{
      System.out.print("Lo sentimos, pero no puede pensionarse an \n");
    }
  }
}
