/**
 * Punto es una clase que representa un punto, con sus coordenadas X,Y. 
 */
public class Punto{
  
  int X;
  int Y;
  
  /**
   * Constructor por defecto de la clase 
   */
  public Punto(){
    this.X = 0;
    this.Y = 0;
  }
  
  /**
   * Constructor sobrecargado 
   */
  public Punto(int X, int Y){
    this.X = X;
    this.Y = Y;
  }
  
  /**
   * Retorna el valor de la variable X
   */
  public int getX(){
    return this.X;
  }
  
  /**
   * Retorna el valor de la variable Y
   */
  public int getY(){
    return this.Y;
  }
  
  /**
   * Establece el valor de la variable X
   */
  public void setX(int X){
    this.X = X;
  }
  
  /**
   * Establece el valor de la variable Y
   */
  public void setY(int Y){
    this.Y = Y;
  }
  
  /**
   * Retorna la distancia entre 2 puntos, la cual es la hipotenusa del tringulo que forma en el plano
   * junto al otro punto            p2  
   *                              /  |
   *             Distancia -->  /    | 
   *                          /      |
   *                        p1-------+
   * Si ambos estn en una misma Y o misma X se restan sus posiciones
   *                      
   *    Misma Y             p1-----------p2
   *  
   *    Misma X             p1
   *                        |
   *                        |
   *                        |
   *                        p2
   */
  public int distanciaEntrePuntos(Punto p1, Punto p2){
    System.out.println("Sacando distancia PUNTO");
    /**
     * Caso en el cual la X es la misma 
     */
    if(p1.getX() == p2.getX()){
      return (p2.getY() - p1.getY());
    }
    /**
     * Caso en el cual la Y es la misma 
     */
    if(p1.getY() == p2.getY()){
      return (p2.getX() - p1.getX());
    }
    /**
     * Caso en el cual hay que encontrar la hipotenusa 
     */
    else{
      System.out.println("Sacando distancia ELSE PUNTO");
      Punto p3 = new Punto(p2.getX(), p1.getY());
      int distanciaP1P3 = p3.getX() - p1.getX();
      int distanciaP3P2 = p2.getY() - p3.getY();
      int hipotenusa = (int)Math.sqrt((Math.pow(distanciaP1P3,2) + Math.pow(distanciaP3P2,2)));
      return hipotenusa;
    }
  }
}