/**
 * Clase que muestra el uso de la recursividad, imprimiendo diversos niveles
 * de identaci&oacute;n
 */
public class Identador{
  /**
   * Representa el nivel de indentaci&oacute;n actual 
   */
  int nivel;  
  
  /**
   * Constructor por defecto 
   */
  public Identador(){   
    this.nivel = 0;
  }
  
  /**
   * Invoca al m&eacute;todo recursivo verRecursividadRecursivo(int nivel, int tope)
   * @param tope indica el nivel m&aacute;ximo de recursividad
   */
  public void verRecursividad(int tope){
    this.verRecursividadRecursivo(nivel,tope);
  }
  
  /**
   *  Imprime los niveles de identaci&oacute;n de manera recursiva
   *  @param nivel nivel de identaci&oacute;n actual
   *  @param tope nivel de identaci&oacute;n m&aacute;ximo
   */
  public void verRecursividadRecursivo(int nivel, int tope){    
    if(nivel == tope){      
      System.out.println("Entra Nivel:"+nivel);
      for(int i=0; i< nivel; i++){
        System.out.print("\t");
      }
      System.out.println("Se cumplio la condicion de parada");
    }
    else{
      System.out.println("Entra Nivel:"+nivel);
      for(int i=0; i<= nivel; i++){
        System.out.print("\t");
      }
      verRecursividadRecursivo((nivel+1),tope);      
      for(int i=0; i< nivel; i++){
        System.out.print("\t");        
      }
      System.out.println("Saliendo de nivel " + nivel);
    }   
  }
  
  /**
   * M&eacute;todo principal 
   */
  public static void main(String args[]){
    Identador i = new Identador();
    i.verRecursividad(3);
  }
}