/**
 * Clase que resuelve el problema de las torres de Hanoi de manera recursiva 
 */
public class Hanoi {
  /**
   * M&eacute;todo est&aacute;tico que invoca a la funci&oacute;n recursiva 
   * resolverR(int discos,String origen,String intermedia, String destino)
   * @param discos cantidad de discos inicial
   */
  public static void resolver(int discos){
    resolverR(discos, "origen","intermedia","destino");
  }
  
  /**
   * M&eacute;todo recursivo que se encarga de encontrar los movimientos apropiados para los discos
   * @param discos cantidad de discos a mover
   * @param origen torre de origen
   * @param intermedia torre intermedia
   * @param destino torre de destino
   */
  private static void resolverR(int discos,String origen,String intermedia, String destino){
    //Condici&oacute;n de parada
    if(discos==1)
      System.out.println("Mueva el disco superior de la torre "+origen+" a la torre "+destino);
    else {
      resolverR(discos-1,origen,destino,intermedia);
      System.out.println("Mueva el disco superior de la torre "+origen+" a la torre "+destino);
      resolverR(discos-1,intermedia,origen,destino);
    }
  }
}