import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Title:        OchoReinasRecursivoYGrafico
 * Description:  Es un conjunto de clases que interactuando, llevan a cabo el problema de las Ocho Reinas Grfica y Recursivamente
 * Copyright:    Copyright (c) 2001
 * Company:      ECCI
 * @author Edgar Casasola Murillo
 * @version 1.0
 */

/**
 * Dibuja el Tablero, representa el control de los eventos a nivel gr&aacute;fico 
 */
public class TableroGrafico extends JPanel {
  /**
   * Tablero que se est&aacute; dibujando 
   */ 
  Tablero tablero;

   /**
    * Constructor de la clase    
    */
   public TableroGrafico() {
     tablero = new Tablero();
   }
   
   /**
    * dibuja el tablero en el panel
    */
   public void paintComponent(Graphics g){
      super.paintComponent(g);  // TIENEN QUE PONERLO
      tablero.dibujar(this,g);
   }
   
   /**
    * pone la ficha en el tablero de la clase 
    * @param ficha Ficha a colocar
    * @param f entero para la fila
    * @param c entero para la columna
    */
   public void ponerFicha(Ficha ficha,int f,int c){
     tablero.ponerFicha(ficha,f,c);
   }

    /**
    * pone la ficha en el tablero de la clase 
    * @param f entero para la fila
    * @param c entero para la columna
    */
   public Ficha sacarFicha(int f, int c){
     return tablero.sacarFicha(f,c);
   }

    /**
    * pone la ficha en el tablero de la clase 
    * @param f entero para la fila
    * @param c entero para la columna
    */
   public boolean hayFicha(int f, int c){
     return tablero.hayFicha(f, c);
   }
}
