import javax.swing.JOptionPane;
/* La clase ManejadorDeVectores se utiliza para demostrar la forma de
 * pasar referencias a vectores como parmetros
 * Pretende mostrar que si un vector es modificado a travs de su refencia
 * dentro de un mtodo, los cambios se mantendrn an al salir del mtodo
 * Tambin muestra como crear y devolver instancias de vector en este caso con un mtodo
 * que fabrica vectores de enteros.
 * Su diseo y estructura obedece solo a fines de demostracin de pase de parmetros
 * Programado por: MSc. Edgar Casasola Murillo (c)2004
 */
public class ManejadorDeVectores {
  /** <pre>
   * REQUIERE: Que el vector recibido como parmetros haya sido inicializado y sea diferente de null
   * EFECTUA: Suma el valor "incremento" a todos los elementos del vector
   * MODIFICA: Modifica los valores de las celdas referenciadas por "vector" sumndoles el "incremento" a cada una.
   * Los cambios llevadoa a cabo sobre el vector se mantendrn an despus de finalizar el mtodo
   * @param vector Es un vector de enteros
   * @param incremento Es un entero que se utilizar para incrementar todos los valores del vector </pre>
   */
  public static void sumarATodos(int vector[],int incremento){
    for(int i=0;i<vector.length; i++){
      vector[i]+=incremento;
    }
  }
   /** <pre>
   * crearVectorDeEnteros es un mtodo "Fbrica" que crea instancias de vector de enteros
   * REQUIERE: Recibir un valor entero mayor que 0
   * EFECTUA: Crea y devuelve un vector de enteros del tamao recibido como parmetro en "cantidadDeCeldas"
   * MODIFICA: No modifica objetos externos al mtodo
   * @param cantidadDeCeldas Es un entero que indica la cantidad de celdas que tendr el vector
   * @return Devuelve una referencia a un vector recin creado con la cantidad de celdas solicitadas </pre>
   */ 
  public static int [] crearVectorDeEnteros(int cantidadDeCeldas){
    return new int [cantidadDeCeldas];
  }
  /** <pre>
   * REQUIERE: Que el vector recibido como parmetro sea diferente de null
   * EFECTUA: Solicita al usuario valores y los asigna a cada celda del vector
   * MODIFICA: Modifica los valores de las celdas referenciadas por "vector" asignando los valores dados por el usuario
   * @param vector Es un vector de enteros
   */ 
  public static void leerVectorDeEnteros(int vector[]){
      for(int i=0;i<vector.length; i++){
        vector[i] = Integer.parseInt(JOptionPane.showInputDialog("Digite el valor "+(i+1)));
    }
  }
   /** <pre>
   * REQUIERE: Recibir una referencia a vector diferente de null
   * EFECTUA: Recorre el vector y crea un String con su contenido
   * MODIFICA: No modifica objetos externos al mtodo
   * @param vector Es un vector de enteros
   * @return Devuelve un String con una representacin del contenido de las celdas del vector </pre>
   */   
  public static String vectorDeEnterosAString(int vector[]){
     String salida="{ ";
     if(vector.length > 0)
       salida+=vector[0];
     for(int i=1;i<vector.length; i++){
        salida+=" , "+vector[i];
    }
     salida+=" }";
     return salida;
  }
}