

import javax.swing.JOptionPane;
import javax.swing.JTextArea;

/**
 * <p>Ttulo: Cuatro en Lnea</p>
 * <p>Descripcin: Simulacin del Juego Cuatro en Lnea </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Compaa: UCR </p>
 * @version 1.0
 */

public class Juego {

  //Main method
  public static void main(String[] args) {

 final int MAX_JUGADORES = 2;

 boolean gano = false;
 boolean libres = true;
 int poscolumna = 0;
 int posfila;
 String xposcolumna;

 Jugador jugador1, jugador2;

 Juego juego = new Juego();

 Tablero tablero1 = new Tablero();

 jugador1 = juego.CreaJugador();
 jugador2 = juego.CreaJugador();

 int turno = 1;

 while (!(gano) && (libres)) {
   if (turno == 1){
  posfila = -1;
  while (posfila == -1) {
    xposcolumna = JOptionPane.showInputDialog(jugador1.getNombre() +
     " en cual columna desea poner la ficha?");
    poscolumna = Integer.parseInt(xposcolumna);
    posfila = tablero1.BuscaFila(poscolumna);
    if (posfila == -1) {
   JOptionPane.showMessageDialog(null, "No hay espacio en esa columna!", "Error", JOptionPane.ERROR_MESSAGE);
    }
  }
  gano = jugador1.juega(tablero1, posfila, poscolumna);
  turno = 2;
   }
   else
   {
  posfila = -1;
  while (posfila == -1) {
    xposcolumna = JOptionPane.showInputDialog(jugador2.getNombre() +
     " en cual columna desea poner la ficha?");
    poscolumna = Integer.parseInt(xposcolumna);
    posfila = tablero1.BuscaFila(poscolumna);
    if (posfila == -1) {
   JOptionPane.showMessageDialog(null, "No hay espacio en esa columna!", "Error", JOptionPane.ERROR_MESSAGE);
    }
  }
  gano = jugador2.juega(tablero1, posfila, poscolumna);
  turno = 1;
   }
   libres = tablero1.EspaciosLibres();
   juego.DibujaTablero(tablero1);
 }
 if (gano) {
   if (turno == 2) {
  JOptionPane.showMessageDialog(null, "Jugador " + jugador1.getNombre() + " ha ganado!", "Fin", JOptionPane.ERROR_MESSAGE);
   }
   else {
  JOptionPane.showMessageDialog(null, "Jugador " + jugador2.getNombre() + " ha ganado!", "Fin", JOptionPane.ERROR_MESSAGE);
   }
 } else {
   JOptionPane.showMessageDialog(null, "No hay espacios disponibles. Nadie ha ganado!", "Fin", JOptionPane.ERROR_MESSAGE);
 }
 System.exit(0);
  }

  /**
   * Despliega el contenido del Tablero
   * @param Tablero que se desea desplegar
   */
  public void DibujaTablero (Tablero ptablero){
 JTextArea areaTextoSalida = new JTextArea();
 areaTextoSalida.setText("Tablero\n");
 areaTextoSalida.append("\tA0\t1\t2\t3\t4\t5\t6\t\n");
 for (int i = 0; i<Tablero.MAX_FILAS; i++){
   areaTextoSalida.append(i+"\t");
   for (int j = 0; j<Tablero.MAX_COLUMNAS; j++) {
  if (ptablero.getCelda(i, j) != null) {
    areaTextoSalida.append(ptablero.getCelda(i, j).getColor() + "\t");
  }
  else{
    areaTextoSalida.append("    " + "\t");
  }
   }
   areaTextoSalida.append("\n");
 }
 JOptionPane.showMessageDialog(null, areaTextoSalida, "Tablero", JOptionPane.INFORMATION_MESSAGE);
  }

  /**
   * Crea los jugadores en el juego
   * @return Devuelve un objeto de la clase Jugador.
   */
  public Jugador CreaJugador() {

 String nombre = JOptionPane.showInputDialog("Cual es su nombre?");

 Object[] possibleValues = { "Azul ", "Rojo ", "Verde" };
 Object selectedValue = JOptionPane.showInputDialog(null,
 "Escoja el color de fichas", "Entrada",
 JOptionPane.INFORMATION_MESSAGE, null,
 possibleValues, possibleValues[0]);
 String color = String.valueOf(selectedValue);

 return new Jugador(nombre, color);

  }
}
