
import javax.swing.JOptionPane;
/* La clase vector se utiliza para demostrar la forma de declarar
 * inicializar y acceder a las celdas de un vector
 * Su diseo y estructura obedece solo a fines de demostracin
 * Programado por: MSc. Edgar Casasola Murillo (c)2004
 */
public class Vector {
  /** Declara una referencia a un vector de enteros como parte de la clase
   */
  private int vector[];
  /** El constructor iniciaciza un vector que contendr tantos enteros
   * como se indique en el parmetro cantidadDeElementos
   * @param cantidadDeElementos Determina el tamao que tendr el vector de enteros
   */
  public Vector(int cantidadDeElementos){
    vector = new int [cantidadDeElementos];
  }
  /** 
   * REQUIERE: Que el vector haya sido declarado
   * EFECTUA: Este mtodo muestra como inicializar cada celda del vector con valores
   * suministrados por el usuario
   * MODIFICA: Modifica los valores de las celdas referenciadas por "vector"
   */
  public void leerVector(){
    for(int i=0;i<vector.length; i++){
      vector[i] = Integer.parseInt(JOptionPane.showInputDialog("Digite el valor "+(i+1)));
    }
  }
  /**
   * REQUIERE: Que el atributo vector haya sido inicializado
   * EFECTUA: Recorre el vector y presenta en la pantalla de consola el contenido de las celdas desde la posicin 0
   * hasta la ltima posicin
   * MODIFICA: La salida a consola.
   */
  public void imprimir(){
    for(int i=0;i<vector.length; i++){
      System.out.println(" "+vector[i]);
    }
  }
  /**
   * REQUIERE: La existencia de la clase Vector
   * EFECTUA: Crea una instancia de Vector con tantas celdas como indique el usuario. 
   * Lee valores suministrados por el usuario y llena sus celdas
   * Posteriormente imprime el contenido almacenado previamente en el Vector
   * MODIFICA: N/A
   */
  public static void main(String argv[]){
    Vector datos = new Vector(Integer.parseInt(JOptionPane.showInputDialog("Cuantos elementos quiere?")));    
    datos.leerVector();
    datos.imprimir();
    System.exit(0);
  }
}